<?php
/*
 * Created For BZ9.com
 * Author: Dave
 * Copyright: BZ9.com
 * Licence: Commercial, See included licence file.
 */
if(!defined("APPLICATION_PATH")){ die("No DIRECT Access"); }

class security
{
    Private $Reg;

    public function __construct($Registry){
        $this->Reg = $Registry;
        $this->Reg->log->log("class_load","Security Class");
    }

    public function get($var,$type,$vartype="string")
    {
        if($type == "post"){
            if(isset($_POST[$var])){
            $item = $this->sanitise($_POST[$var],$vartype);

            return $item;
            }
        }
        if($type == "get"){
            if(isset($_GET[$var])){
            $item = $this->sanitise($_GET[$var],$vartype);
            return $item;
            }
        }
        if($type == "server"){
            if(isset($_GET[$var])){
                $item = $this->sanitise($_SERVER[$var],$vartype);
                return $item;
            }
        }
        if($type == "session"){
            if(isset($_GET[$var])){
                $item = $this->sanitise($_SESSION[$var],$vartype);
                return $item;
            }
        }
        return false;
    }

    public function sanitise($var,$vartype="string")
    {
        if(!$var){return false;}

        if($vartype == "string"){
            $new_var = trim(filter_var($var, FILTER_SANITIZE_STRING));
            return $new_var;
        }
        if($vartype == "email"){
            $new_var = trim(filter_var($var, FILTER_SANITIZE_EMAIL));
            return $new_var;
        }

        if($vartype == "int"){
            $new_var = trim(filter_var($var, FILTER_SANITIZE_NUMBER_INT));
            return $new_var;
        }

        if($vartype == "url"){
            $new_var = trim(filter_var($var, FILTER_SANITIZE_URL));
            return $new_var;
        }

        return false;
    }

    public function validate($string,$type,$data=null)
    {
        if(!$string){ return false; }
        if(!$type){ return false; }

        //preg_match
        if($type == "match")
        {
            if(!$data){ return false; }
            if(!preg_match($data,$string))
            {

                return false;
            }
            return true;
        }

        //email
        if($type == "email")
        {
            if(!filter_var($string, FILTER_VALIDATE_EMAIL)){
               return false;
            }
            return true;
        }

        //url
        if($type == "url")
        {
            if(!filter_var($string, FILTER_VALIDATE_URL)){
                return false;
            }
            return true;
        }
        //option
        if($type == "option")
        {
            $optarray = explode(":",$data);

            foreach($optarray as $key => $value)
            {
                if($string == $value)
                {
                    return true;
                }
            }
            return false;
        }

        if($type == "date")
        {
            if (date($data, strtotime($string)) == $string) {
                return true;
            } else {
                return false;
            }
        }

        //nothing to do
        return false;
    }

}
